> ## Documentation Index
> Fetch the complete documentation index at: https://docs.getruba.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create File

> ### Intent

Creates a file from the values supplied in the request.

### When to call it

Call this when your application has collected the required values and is ready to create a file.

### Access boundary

Authorize the request with a token that carries `files:write`.

### Successful result

A successful request returns `201`. The response schema below defines the body your integration receives.

export const RubaSocials = () => {
  if (typeof document === "undefined") {
    return null;
  }
  const inject = () => {
    const footer = document.getElementById("footer");
    if (!footer || document.getElementById("ruba-socials")) {
      return false;
    }
    const isDark = document.querySelector("html.dark") || document.querySelector('html[class*="dark"]');
    const lineColor = isDark ? "#383838" : "#e8e8ed";
    const iconColor = isDark ? "#8e8e93" : "#86868b";
    const markColor = isDark ? "#ffffff" : "#08080c";
    const hoverColor = "#0071e3";
    const div = document.createElement("div");
    div.id = "ruba-socials";
    div.style.cssText = `display:flex;align-items:center;gap:20px;padding-top:20px;margin-top:20px;border-top:1px solid ${lineColor};width:100%`;
    const logo = `<a href="https://getruba.com" style="display:inline-flex;height:24px;align-items:center;gap:8px;text-decoration:none;color:${markColor};line-height:1;"><svg width="24" height="24" viewBox="0 0 120 120" aria-hidden="true" style="display:block;flex:none;"><g transform="translate(2.5 0)"><path d="M19 25h59L65.43 47H19a4 4 0 0 1-4-4V29a4 4 0 0 1 4-4Z" fill="${markColor}"/><path d="M19 73h31.57L38 95H19a4 4 0 0 1-4-4V77a4 4 0 0 1 4-4Z" fill="${markColor}"/><path d="M85 25h25L70 95H45Z" fill="#007AFF"/></g></svg><span style="display:inline-flex;height:24px;align-items:center;font-weight:600;font-size:15px;color:${markColor};letter-spacing:-0.01em;line-height:1;">Ruba</span></a>`;
    const spacer = `<div style="flex:1"></div>`;
    const ig = `<a href="https://instagram.com/getruba" target="_blank" rel="noopener" aria-label="Instagram" style="display:flex;align-items:center;color:${iconColor};transition:color 0.15s ease;" onmouseover="this.style.color='${hoverColor}'" onmouseout="this.style.color='${iconColor}'"><svg width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="1.8" stroke-linecap="round" stroke-linejoin="round"><rect x="2" y="2" width="20" height="20" rx="5" ry="5"/><path d="M16 11.37A4 4 0 1 1 12.63 8 4 4 0 0 1 16 11.37z"/><line x1="17.5" y1="6.5" x2="17.51" y2="6.5"/></svg></a>`;
    const li = `<a href="https://linkedin.com/company/getruba" target="_blank" rel="noopener" aria-label="LinkedIn" style="display:flex;align-items:center;color:${iconColor};transition:color 0.15s ease;" onmouseover="this.style.color='${hoverColor}'" onmouseout="this.style.color='${iconColor}'"><svg width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="1.8" stroke-linecap="round" stroke-linejoin="round"><path d="M16 8a6 6 0 0 1 6 6v7h-4v-7a2 2 0 0 0-2-2 2 2 0 0 0-2 2v7h-4v-7a6 6 0 0 1 6-6z"/><rect x="2" y="9" width="4" height="12"/><circle cx="4" cy="4" r="2"/></svg></a>`;
    const x = `<a href="https://x.com/getruba" target="_blank" rel="noopener" aria-label="X" style="display:flex;align-items:center;color:${iconColor};transition:color 0.15s ease;" onmouseover="this.style.color='${hoverColor}'" onmouseout="this.style.color='${iconColor}'"><svg width="18" height="18" viewBox="0 0 24 24" fill="currentColor"><path d="M18.244 2.25h3.308l-7.227 8.26 8.502 11.24H16.17l-5.214-6.817L4.99 21.75H1.68l7.73-8.835L1.254 2.25H8.08l4.713 6.231zm-1.161 17.52h1.833L7.084 4.126H5.117z"/></svg></a>`;
    const github = `<a href="https://github.com/rubadot" target="_blank" rel="noopener" aria-label="GitHub" style="display:flex;align-items:center;color:${iconColor};transition:color 0.15s ease;" onmouseover="this.style.color='${hoverColor}'" onmouseout="this.style.color='${iconColor}'"><svg width="20" height="20" viewBox="0 0 24 24" fill="currentColor"><path d="M12 .7a11.5 11.5 0 0 0-3.64 22.4c.58.1.79-.25.79-.56v-2.24c-3.22.7-3.9-1.37-3.9-1.37-.53-1.34-1.29-1.7-1.29-1.7-1.05-.72.08-.71.08-.71 1.16.08 1.78 1.2 1.78 1.2 1.04 1.77 2.72 1.26 3.38.96.1-.75.4-1.26.74-1.55-2.57-.3-5.27-1.29-5.27-5.69 0-1.26.45-2.29 1.19-3.09-.12-.29-.52-1.47.11-3.05 0 0 .97-.31 3.16 1.18A10.96 10.96 0 0 1 12 6.09c.98 0 1.94.13 2.86.39 2.2-1.49 3.16-1.18 3.16-1.18.63 1.58.23 2.76.11 3.05.74.8 1.19 1.83 1.19 3.09 0 4.42-2.7 5.39-5.28 5.68.42.36.79 1.06.79 2.14v3.28c0 .31.21.67.8.56A11.5 11.5 0 0 0 12 .7Z"/></svg></a>`;
    div.innerHTML = logo + spacer + ig + li + x + github;
    footer.appendChild(div);
    return true;
  };
  if (!document.documentElement.dataset.rubaSocialsObserver) {
    document.documentElement.dataset.rubaSocialsObserver = "true";
    const observer = new MutationObserver(() => {
      if (!document.getElementById("ruba-socials")) {
        inject();
      }
    });
    observer.observe(document.body, {
      childList: true,
      subtree: true
    });
  }
  setTimeout(() => {
    if (!inject()) {
      const interval = setInterval(() => {
        if (inject()) {
          clearInterval(interval);
        }
      }, 500);
      setTimeout(() => clearInterval(interval), 10000);
    }
  }, 300);
  return null;
};

<link rel="stylesheet" href="/style.css" />

<RubaSocials />


## OpenAPI

````yaml post /v1/files/
openapi: 3.1.0
info:
  title: Ruba API
  summary: Ruba HTTP and Webhooks API
  description: '**Details:** Read the docs at https://docs.getruba.com/api-reference.'
  version: 2026-04
servers:
  - url: https://api.getruba.com
    description: '**Details:** Production environment.'
    x-speakeasy-server-id: production
  - url: https://sandbox-api.getruba.com
    description: '**Details:** Sandbox environment.'
    x-speakeasy-server-id: sandbox
security: []
tags:
  - name: public
    description: >-
      **Details:** Endpoints shown and documented in the Ruba API documentation
      and available in our SDKs.
  - name: private
    description: >-
      **Details:** Endpoints that should appear in the schema only in
      development to generate our internal JS SDK.
paths:
  /v1/files/:
    post:
      tags:
        - files
        - public
      summary: Create File
      description: >-
        ### Intent


        Creates a file from the values supplied in the request.


        ### When to call it


        Call this when your application has collected the required values and is
        ready to create a file.


        ### Access boundary


        Authorize the request with a token that carries `files:write`.


        ### Successful result


        A successful request returns `201`. The response schema below defines
        the body your integration receives.
      operationId: files:create
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/FileCreate'
      responses:
        '201':
          description: '**Response:** File created.'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/FileUpload'
        '422':
          description: Request validation failed
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - oidc:
            - files:write
        - pat:
            - files:write
        - oat:
            - files:write
components:
  schemas:
    FileCreate:
      oneOf:
        - $ref: '#/components/schemas/DownloadableFileCreate'
        - $ref: '#/components/schemas/ProductMediaFileCreate'
        - $ref: '#/components/schemas/OrganizationAvatarFileCreate'
        - $ref: '#/components/schemas/SupportCaseAttachmentFileCreate'
      discriminator:
        propertyName: service
        mapping:
          downloadable:
            $ref: '#/components/schemas/DownloadableFileCreate'
          organization_avatar:
            $ref: '#/components/schemas/OrganizationAvatarFileCreate'
          product_media:
            $ref: '#/components/schemas/ProductMediaFileCreate'
          support_case_attachment:
            $ref: '#/components/schemas/SupportCaseAttachmentFileCreate'
    FileUpload:
      properties:
        id:
          type: string
          format: uuid4
          title: Id
          description: The stable identifier for this record.
        organization_id:
          type: string
          format: uuid4
          title: Organization Id
        name:
          type: string
          title: Name
        path:
          type: string
          title: Path
        mime_type:
          type: string
          title: Mime Type
        size:
          type: integer
          title: Size
        storage_version:
          anyOf:
            - type: string
            - type: 'null'
          title: Storage Version
        checksum_etag:
          anyOf:
            - type: string
            - type: 'null'
          title: Checksum Etag
        checksum_sha256_base64:
          anyOf:
            - type: string
            - type: 'null'
          title: Checksum Sha256 Base64
        checksum_sha256_hex:
          anyOf:
            - type: string
            - type: 'null'
          title: Checksum Sha256 Hex
        last_modified_at:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Last Modified At
        upload:
          $ref: '#/components/schemas/S3FileUploadMultipart'
        version:
          anyOf:
            - type: string
            - type: 'null'
          title: Version
        is_uploaded:
          type: boolean
          title: Is Uploaded
          default: false
        service:
          $ref: '#/components/schemas/FileServiceTypes'
        size_readable:
          type: string
          title: Size Readable
          readOnly: true
      type: object
      required:
        - id
        - organization_id
        - name
        - path
        - mime_type
        - size
        - storage_version
        - checksum_etag
        - checksum_sha256_base64
        - checksum_sha256_hex
        - last_modified_at
        - upload
        - version
        - service
        - size_readable
      title: FileUpload
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    DownloadableFileCreate:
      properties:
        organization_id:
          anyOf:
            - type: string
              format: uuid4
              description: Identifier of the organization.
              examples:
                - 1dbfc517-0bbf-4301-9ba8-555ca42b9737
              x-ruba-selector-widget:
                displayProperty: name
                resourceName: Organization
                resourceRoot: /v1/organizations
            - type: 'null'
          title: Organization Id
        name:
          type: string
          title: Name
        mime_type:
          type: string
          title: Mime Type
        size:
          type: integer
          title: Size
        checksum_sha256_base64:
          anyOf:
            - type: string
            - type: 'null'
          title: Checksum Sha256 Base64
        upload:
          $ref: '#/components/schemas/S3FileCreateMultipart'
        service:
          type: string
          const: downloadable
          title: Service
        version:
          anyOf:
            - type: string
            - type: 'null'
          title: Version
      type: object
      required:
        - name
        - mime_type
        - size
        - upload
        - service
      title: DownloadableFileCreate
      description: >-
        Schema used to create a file to be associated with the downloadables
        benefit.
    ProductMediaFileCreate:
      properties:
        organization_id:
          anyOf:
            - type: string
              format: uuid4
              description: Identifier of the organization.
              examples:
                - 1dbfc517-0bbf-4301-9ba8-555ca42b9737
              x-ruba-selector-widget:
                displayProperty: name
                resourceName: Organization
                resourceRoot: /v1/organizations
            - type: 'null'
          title: Organization Id
        name:
          type: string
          title: Name
        mime_type:
          type: string
          pattern: ^image\/(jpeg|png|gif|webp|svg\+xml)$
          title: Mime Type
          description: >-
            **Mime Type:** MIME type of the file. Only images are supported for
            this type of file.
        size:
          type: integer
          maximum: 10485760
          title: Size
          description: >-
            **Size:** Size of the file. A maximum of 10 MB is allowed for this
            type of file.
        checksum_sha256_base64:
          anyOf:
            - type: string
            - type: 'null'
          title: Checksum Sha256 Base64
        upload:
          $ref: '#/components/schemas/S3FileCreateMultipart'
        service:
          type: string
          const: product_media
          title: Service
        version:
          anyOf:
            - type: string
            - type: 'null'
          title: Version
      type: object
      required:
        - name
        - mime_type
        - size
        - upload
        - service
      title: ProductMediaFileCreate
      description: Schema used to create a file to be used as a product media file.
    OrganizationAvatarFileCreate:
      properties:
        organization_id:
          anyOf:
            - type: string
              format: uuid4
              description: Identifier of the organization.
              examples:
                - 1dbfc517-0bbf-4301-9ba8-555ca42b9737
              x-ruba-selector-widget:
                displayProperty: name
                resourceName: Organization
                resourceRoot: /v1/organizations
            - type: 'null'
          title: Organization Id
        name:
          type: string
          title: Name
        mime_type:
          type: string
          pattern: ^image\/(jpeg|png|gif|webp|svg\+xml)$
          title: Mime Type
          description: >-
            **Mime Type:** MIME type of the file. Only images are supported for
            this type of file.
        size:
          type: integer
          maximum: 1048576
          title: Size
          description: >-
            **Size:** Size of the file. A maximum of 1 MB is allowed for this
            type of file.
        checksum_sha256_base64:
          anyOf:
            - type: string
            - type: 'null'
          title: Checksum Sha256 Base64
        upload:
          $ref: '#/components/schemas/S3FileCreateMultipart'
        service:
          type: string
          const: organization_avatar
          title: Service
        version:
          anyOf:
            - type: string
            - type: 'null'
          title: Version
      type: object
      required:
        - name
        - mime_type
        - size
        - upload
        - service
      title: OrganizationAvatarFileCreate
      description: Schema used to create a file to be used as an organization avatar.
    SupportCaseAttachmentFileCreate:
      properties:
        organization_id:
          anyOf:
            - type: string
              format: uuid4
              description: Identifier of the organization.
              examples:
                - 1dbfc517-0bbf-4301-9ba8-555ca42b9737
              x-ruba-selector-widget:
                displayProperty: name
                resourceName: Organization
                resourceRoot: /v1/organizations
            - type: 'null'
          title: Organization Id
        name:
          type: string
          title: Name
        mime_type:
          type: string
          pattern: >-
            ^(image\/(jpeg|png|gif|webp)|video\/(mp4|quicktime|webm)|application\/pdf|text\/(csv|plain)|application\/msword|application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document|application\/vnd\.ms-excel|application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet)$
          title: Mime Type
          description: >-
            **Mime Type:** MIME type of the file. Images, videos, PDF, CSV,
            plain text, Word and Excel documents are supported.
        size:
          type: integer
          maximum: 262144000
          title: Size
          description: >-
            **Size:** Size of the file. A maximum of 250 MB is allowed for this
            type of file.
        checksum_sha256_base64:
          anyOf:
            - type: string
            - type: 'null'
          title: Checksum Sha256 Base64
        upload:
          $ref: '#/components/schemas/S3FileCreateMultipart'
        service:
          type: string
          const: support_case_attachment
          title: Service
        version:
          anyOf:
            - type: string
            - type: 'null'
          title: Version
      type: object
      required:
        - name
        - mime_type
        - size
        - upload
        - service
      title: SupportCaseAttachmentFileCreate
      description: Schema used to create a file attached to a support case.
    S3FileUploadMultipart:
      properties:
        id:
          type: string
          title: Id
        path:
          type: string
          title: Path
        parts:
          items:
            $ref: '#/components/schemas/S3FileUploadPart'
          type: array
          title: Parts
      type: object
      required:
        - id
        - path
        - parts
      title: S3FileUploadMultipart
    FileServiceTypes:
      type: string
      enum:
        - downloadable
        - product_media
        - organization_avatar
        - support_case_attachment
      title: FileServiceTypes
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    S3FileCreateMultipart:
      properties:
        parts:
          items:
            $ref: '#/components/schemas/S3FileCreatePart'
          type: array
          title: Parts
      type: object
      required:
        - parts
      title: S3FileCreateMultipart
    S3FileUploadPart:
      properties:
        number:
          type: integer
          title: Number
        chunk_start:
          type: integer
          title: Chunk Start
        chunk_end:
          type: integer
          title: Chunk End
        checksum_sha256_base64:
          anyOf:
            - type: string
            - type: 'null'
          title: Checksum Sha256 Base64
        url:
          type: string
          title: Url
        expires_at:
          type: string
          format: date-time
          title: Expires At
        headers:
          additionalProperties:
            type: string
          type: object
          title: Headers
          default: {}
      type: object
      required:
        - number
        - chunk_start
        - chunk_end
        - url
        - expires_at
      title: S3FileUploadPart
    S3FileCreatePart:
      properties:
        number:
          type: integer
          title: Number
        chunk_start:
          type: integer
          title: Chunk Start
        chunk_end:
          type: integer
          title: Chunk End
        checksum_sha256_base64:
          anyOf:
            - type: string
            - type: 'null'
          title: Checksum Sha256 Base64
      type: object
      required:
        - number
        - chunk_start
        - chunk_end
      title: S3FileCreatePart
  securitySchemes:
    oidc:
      type: openIdConnect
      openIdConnectUrl: /.well-known/openid-configuration
    pat:
      type: http
      description: >-
        **Authentication:** You can generate a **Personal Access Token** from
        your [settings](https://getruba.com/settings).
      scheme: bearer
    oat:
      type: http
      description: >-
        **Authentication:** You can generate an **Organization Access Token**
        from your organization's settings.
      scheme: bearer

````